AJS.$.ajaxSetup({ cache: false });
AJS.$(function($){

    var $privacyForm = $("#setup-privacy");
    if ($privacyForm.size() > 0) {
        $privacyForm.find("#button-next").click(function(e){
            e.preventDefault();
            $.ajax({
                url: AJS.contextPath() + "/rest/playsql/1.0/admin/setup",
                type: 'PUT',
                contentType: "application/json; charset=utf-8",
                cache: false,
                dataType: "json",
                data: JSON.stringify({
                    "accept-policy": true
                })
            }).done(function(data) {
                window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-training";
            }).fail(function(jqXHR, errorMessage, errorObject){
                AJS.messages.error("#all-messages", {
                    title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.save-setting"),
                    //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                    closeable: true
                });
            });
            return false;
        });
    }

    var $permissionsForm = $("#setup-permissions");
    if ($permissionsForm.size() > 0) {
        var changeHandler = function () {
            var $this = $(this),
                name = $this.attr("name"),
                value = $this.attr("type") == "checkbox" ? $this.is(":checked") : $this.val(),
                data = {};
            data[name] = "" + value;
            $.ajax({
                url: AJS.contextPath() + "/rest/playsql/1.0/admin/setup",
                type: 'PUT',
                contentType: "application/json",
                data: JSON.stringify(data),
                success: function (data) {
                    // Alright
                }, error: function (jqXHR, errorMessage, errorObject) {
                    // TODO Adrien Check that' the right name
                    AJS.messages.error("#all-messages", {
                        title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.save-setting"),
                        //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                        closeable: true
                    });
                }
            });
        };
        $("#sidebarLinkEnabled, #spaceAdminUpdatePermission").click(changeHandler);
        $("#maxRecords").change(changeHandler);
    }

    var dbStep = 0;
    if ($("#db-already-setup").size() == 1) {
        dbStep = -1;
    }
    $("#db-setup-btn").click(function(e){
        e.preventDefault();
        var resetDb = $("input[name=setup-reset]:checked").val(),
            setupType = $("input[name=setup-type]:checked").val(),
            vendor = $("input[name=vendor]:checked").val(),
            vendorText = $("label[for='" + vendor + "']").text(),
            jndiName = $("#jndi-custom").val(),
            spaceList = $(".space-list li").map(function(){ return $(this).attr("data-space-key"); }),
            iWillInformUsers = $("#i-will-inform-users:checked").size() > 0,
            email = $("input[name=provisioning-api-email]").val();

        setErrorMessage("");
        switch (dbStep) {
            case -1:
                // Database setup was already performed
                if (resetDb == "db-reset") {
                    setupPlaySQLErase(undefined, function(){
                        window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db";
                    });
                } else if (resetDb == "db-reset-hsql") {
                    setupPlaySQLErase("hsql", function(){
                        window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db";
                    });
                } else if (resetDb == "db-no-reset") {
                    dbStep = 0;
                    $("#db-already-setup").addClass("hidden");
                    $("#db-part-1").removeClass("hidden");
                    return false;
                } else {
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required"));
                    return false;
                }
                return false;
            case 0:
                if (setupType == "db-spreadsheets") {
                    $("#db-part-1").addClass("hidden");
                    $("#db-part-vendor").removeClass("hidden");
                    dbStep = 1;
                } else if (setupType == "db-read-only") {
                    $("#db-part-1").addClass("hidden");
                    $("#db-part-read-only").removeClass("hidden");
                    dbStep = 100;
                } else if (setupType == "db-eval") {
                    $("#db-part-1").addClass("hidden");
                    $("#db-part-eval").removeClass("hidden");
                    dbStep = 10;
                } else if (setupType == "db-oz") {
                    $("#db-part-1").addClass("hidden");
                    $("#db-part-oz-the-wizard").removeClass("hidden");
                    dbStep = 100;
                } else {
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
                    return false;
                }
                break;
            case 1:
                if (!vendor) {
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
                    return false;
                } else if (vendor == "heroku") {
                    if (!email || email.indexOf("@") == -1) {
                        setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
                        return false;
                    }
                    setupPlaySQLHeroku(email, function(){
                        window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-heroku";
                    });
                    dbStep = 1;
                } else {
                    $("#db-part-vendor").addClass("hidden");
                    $("#db-part-select-jndi").removeClass("hidden");
                    dbStep = 3;
                }
                return false;
            case 3:
                if (!jndiName) {
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.jndi"));
                    return false;
                }
                $("#db-summary-vendor").text(vendorText);
                $("#db-summary-jndi").text(jndiName);

                $("#db-part-select-jndi").addClass("hidden");
                $("#db-part-finish").removeClass("hidden");
                dbStep = 4;
                return false;
            case 4:
                setupPlaySQLProd(vendor, jndiName, function(){
                    window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db-manually";
                });
                return false;
            case 10:
                if (!iWillInformUsers) {
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.must-inform-users"));
                    return false;
                }
                setupPlaySQLEval(spaceList, function(){
                    window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db-manually";
                });
                return false;
            case 100:
                window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db-manually";
                return false;
            default:
                return false;
        }
    });
    $("#db-setup-back-btn").click(function(){
        dbStep = 0;
        $("#db-part-1").removeClass("hidden");
        $("#db-part-vendor").addClass("hidden");
        $("#db-part-jndi").addClass("hidden");
        $("#db-part-read-only").addClass("hidden");
        $("#db-part-select-jndi").addClass("hidden");
        $("#db-part-no-jndi").addClass("hidden");
        $("#db-part-finish").addClass("hidden");
        $("#db-part-eval").addClass("hidden");
        $("#db-part-oz-the-wizard").addClass("hidden");
    });

    $("input[name=jndi]").click(function(){
        $("#jndi-custom").val($(this).val());
    });
    $("input[name=vendor]").click(function(){
        if ($("input[name=vendor]:checked").val() == "heroku") {
            $(".saas-terms-of-service").removeClass("hidden");
        } else {
            $(".saas-terms-of-service").addClass("hidden");
        }
    });
    $("#button-sync").click(function(e){
        e.preventDefault();
        var email = $("input[name=provisioning-api-email]").val();
        if (!email || email.indexOf("@") == -1) {
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
            return false;
        }
        checkHerokuStatus(email);
        return false;
    });
    $("#button-transfer-ownership").click(function(e){
        e.preventDefault();
        var account = $("input[name=heroku-account]").val();
        if (!account || account.indexOf("@") == -1) {
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
            return false;
        }
        transferHerokuAccount(account);
        return false;
    });
    $("#button-disconnect-db").click(function(e){
        e.preventDefault();
        disconnectDb();
        return false;
    });
    $("#button-setup-heroku").click(function(e){
        e.preventDefault();
        var email = $("input[name=provisioning-api-email]").val();
        if (!email || email.indexOf("@") == -1) {
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.required.one"));
            return false;
        }
        setupPlaySQLHeroku(email, function(){
            $("#button-setup-heroku").remove();
            $("#button-next").removeClass("hidden");
        });
    });

    // -- Beginning of shitty space list management
    var $spaceAutocompleteUl = $("#space-autocomplete ul");
    $.ajax({
        url : AJS.contextPath() + "/rest/create-dialog/1.0/spaces?promotedSpacesLimit=5&otherSpacesLimit=1000",
        cache: false,
        success : function(data) {
            var countPromoted = 0;
            for (var i = 0; i < data.promotedSpaces.spaces.length; i++) {
                countPromoted++;
                addElement(data.promotedSpaces.spaces[i].id, data.promotedSpaces.spaces[i].text, "promoted");
            }
            for (var i = 0; i < data.otherSpaces.spaces.length; i++) {
                addElement(data.otherSpaces.spaces[i].id, data.otherSpaces.spaces[i].text,
                    countPromoted++ < 5 ? "promoted" : undefined);
            }
            autocompleteSpaces();
        }
    });
    function addElement(key, name, className) {
        var $li = $("<li></li>", {
                "class": "hidden" + (className ? " " + className : "")
            }).appendTo($spaceAutocompleteUl),
            $a = $("<a></a>", {
                href: '#',
                text: name + " (" + key + ")",
                "data-space-key": key,
                "data-space-name": name
            }).appendTo($li);
        $a.click(selectAutocompletedSpace);
    }
    function selectAutocompletedSpace() {
        var $selected = $(this),
            spaceKey = $selected.attr("data-space-key"),
            spaceName = $selected.attr("data-space-name");
        // Set the value and hide the popup
        addSpace(spaceKey, spaceName);
        $selected.remove();
        $("#add-space-name")
            .val(spaceName)
            .trigger("aui-button-invoke");
        return false;
    }
    function autocompleteSpaces(startsWith) {
        if (!startsWith) {
            $spaceAutocompleteUl.children().addClass("hidden");
            $spaceAutocompleteUl.children(".promoted").removeClass("hidden disabled");
        } else {
            $spaceAutocompleteUl.children().each(function(){
                var $this = $(this),
                    $a = $this.children().first(),
                    spaceKey = $a.attr("data-space-key") || "",
                    spaceName = $a.attr("data-space-name") || "",
                    beginning = startsWith.toLowerCase(),
                    alreadyAdded = $(".space-list li[data-space-key='" + spaceKey + "']").size() == 1;
                $a.removeClass("disabled");
                if (!alreadyAdded && (spaceKey.toLowerCase().indexOf(beginning) != -1
                    || spaceName.toLowerCase().indexOf(beginning) != -1)) {
                    $this.removeClass("hidden disabled active");
                } else {
                    $this.addClass("hidden");
                }
            });
        }
    }
    $("#add-space-name").keyup(function(){
        var value = $(this).val();
        autocompleteSpaces(value);

        if ($("#add-space-name:visible").size() == 0)
            $("#add-space-name").trigger("aui-button-invoke");
    }).keydown(function(e){
        var $input = $(this);
        if (e.which == 13) {
            addSpace($input.val(), $input.val());
            return false;
        }
    }).click(function(){
        $(this).select();
    }).attr('aria-owns', 'space-autocomplete')
      .attr('aria-haspopup', 'true')
      .addClass('aui-dropdown2-trigger');

    function addSpace(key, value) {
        $(".space-list").find("li[data-space-key='" + key + "']").remove();

        var $removeLink = $("<a></a>").text("remove"),
            $li = $("<li></li>", {
                text: value + " (" + key + ") - ",
                "data-space-key": key
            }).append($removeLink);
        $(".space-list").prepend($li);
    }

    $("#space-autocomplete").on({
        "aui-dropdown2-show": function() {
            $("#add-space-name").focus();
        }
    });
    $(".space-list").on("click", "li a", function() {
        $(this).closest("li").remove();
    });
    // -- End of space list management

    // Start Play SQL setup methods
    function setupPlaySQLEval(spaceList, callback) {
        setWait(true);
        var rootDatasource;
        $.ajax({
            url: AJS.contextPath() + '/rest/playsql/1.0/datasources?contextName=Factory%20Settings',
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            cache: false
        }).done(function(data) {
            if (data.length != 1) {
                AJS.logError("Unexpected answer about datasources - " + data);
                return;
            }
            rootDatasource = data[0];
            proceed();
        }).fail(function(jqXHR, errorMessage, errorObject){
            setWait(false);
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.save-setting-2"));
            AJS.logError("Couldn't perform setup because there are no Factory Settings - " + jqXHR + " - " + errorMessage + " - " + errorObject);
        });
        function proceed() {
            if (spaceList.length > 0) {
                var url = AJS.contextPath() + '/rest/playsql/1.0/datasources',
                    datasource = {
                        context: { spaceKey : spaceList[0] },
                        type: "DIRECT",
                        driver: rootDatasource.driver,
                        dialect: rootDatasource.dialect,
                        url: rootDatasource.url,
                        username: rootDatasource.username,
                        password: rootDatasource.password,
                        initSQL: rootDatasource.initSQL,
                        schema: rootDatasource.schema,
                        closeSQL: rootDatasource.closeSQL,
                        testSQL: rootDatasource.testSQL,
                        mode: rootDatasource.mode
                    }
                $.ajax({
                    url: url,
                    type: 'POST',
                    cache: false,
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    data: JSON.stringify(datasource)
                }).done(function(data) {
                    spaceList.splice(0, 1);
                    proceed();
                }).fail(function(jqXHR, errorMessage, errorObject){
                    setWait(false);
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.save-setting-2"));
                    AJS.logError("The settings couldn't be saved - " + jqXHR + " - " + errorMessage + " - " + errorObject);
                });
            } else {
                //setWait(false);
                callback();
            }
        }
    }

    function setupPlaySQLErase(withHsql, callback) {
        setWait(true);
        var allConnections;
        $.ajax({
            url: AJS.contextPath() + '/rest/playsql/1.0/datasources',
            type: 'GET',
            cache: false,
            contentType: "application/json; charset=utf-8"
        }).done(function(data) {
            allConnections = data;
            proceed();
        }).fail(function(jqXHR, errorMessage, errorObject){
            setWait(false);
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.reset-setting"));
            AJS.logError("Couldn't perform setup because there are no Factory Settings - " + jqXHR + " - " + errorMessage + " - " + errorObject);
        });
        function proceed() {
            for (var i in allConnections) {
                var cnx = allConnections[i],
                    doDelete = false;
                if (!cnx.context) {
                    setWait(false);
                    setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.remove-setting"));
                    AJS.logError("Couldn't perform clean-up - " + jqXHR + " - " + errorMessage + " - " + errorObject);
                    return;
                }
                if (cnx.context.name == "Factory Settings") continue;
                if (cnx.context.name == undefined && cnx.context.spaceKey == undefined) {
                    // Remove global cnx, if any
                    if (cnx.type == "DIRECT" || cnx.type == "JNDI" || cnx.type == "INHERIT") {
                        doDelete = true;
                    }
                }
                // Do not delete space cnx in any case, and let disabled spaces be disabled
                else if (cnx.context.spaceKey != undefined) {
                    if (withHsql == "hsql") {
                        if (cnx.type == "DIRECT" && cnx.dialect == "com.playsql.jdbc.dialect.HsqlDDLDialect") {
                            doDelete = true;
                        }
                    } else {
                        if (cnx.type != "DISABLED")
                            doDelete = true;
                    }
                }
                if (doDelete) {
                    removeCnx(cnx, function() {
                        allConnections.splice(i, 1);
                        proceed();
                    });
                    return;
                }
            }
            // There is no connection left
            callback();
        }
    }
    function removeCnx(cnx, callback) {
        var url = AJS.contextPath() + '/rest/playsql/1.0/datasources';
        if (cnx.context.name == undefined && cnx.context.spaceKey == undefined) {
            cnx.type = "DISABLED";
        } else {
            cnx.type = "INHERIT";
        }
        $.ajax({
            url: url,
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: "json",
            data: JSON.stringify(cnx)
        }).done(function(data) {
            callback();
        }).fail(function(jqXHR, errorMessage, errorObject){
            setWait(false);
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.remove-connection"));
            AJS.logError("The settings couldn't be saved - " + jqXHR + " - " + errorMessage + " - " + errorObject);
        });
    }
    function setupPlaySQLHeroku(email, callback) {
        setWait(true);
        var url = AJS.contextPath() + '/rest/playsql/1.0/provisioning';
        setErrorMessage("Creating an account. Please wait...");
        $.ajax({
            url: url + "/open",
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: 'text',
            data: JSON.stringify({email: email})
        }).done(function(data) {
            setErrorMessage("Provisioning a database. Please wait...");

            $.ajax({
                url: url + "/createdb",
                type: 'POST',
                contentType: "application/json; charset=utf-8",
                dataType: 'text',
                cache: false
            }).done(function(data) {
                setErrorMessage("Waiting for the database credentials. Please wait...");
                setWait(false);
                var countDown1 = 30;
                var countDown2 = 60;

                function didWeGetTheCredentialsYet(){
                    countDown1--;
                    countDown2--;

                    $.ajax({
                        url: url + "/syncdb",
                        type: 'POST',
                        contentType: "application/json; charset=utf-8",
                        cache: false,
                        dataType: 'json',
                        data: "{}"
                    }).done(function(data) {
                        if (data && data.status == "NOT_YET") {
                            if (countDown2 == 0) {
                                setErrorMessage("The database provisioning is too long. Check your connection to the Internet and come back to this page later.");
                                setWait(false);
                                return;
                            }
                            if (countDown1 == 0) {
                                setErrorMessage("The database provisioning seems a bit long. Let's wait a little more...");
                            }
                            window.setTimeout(didWeGetTheCredentialsYet, 1000);
                        } else if (data && data.status == "PROVISIONED") {
                            setErrorMessage("Success.");
                            setWait(false);
                            callback && callback();
                        } else {
                            if (data && typeof data == "object") {
                                setErrorMessage(data.status + "-" + data.message);
                            } else {
                                setErrorMessage(data);
                            }
                            setWait(false);
                        }
                    }).fail(function(jqXHR, errorMessage, errorObject){
                        var errorMessage = "";
                        try {
                            errorMessage  = JSON.parse(jqXHR.responseText).message;
                        } catch (err){
                            errorMessage = jqXHR.responseText;
                        }
                        if (errorMessage.length>170) {
                            errorMessage = errorMessage.substr(0, 150) + "...";
                        }
                        AJS.log("The online database couldn't be setup up right now: " + jqXHR.responseText);
                        setWait(false);
                        setErrorMessage("");
                        AJS.messages.error("#all-messages", {
                            title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.heroku.create.error", errorMessage),
                            //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                            closeable: true
                        });
                    });
                }
                didWeGetTheCredentialsYet();
                //callback && callback();
            }).fail(function(jqXHR, errorMessage, errorObject){
                var errorMessage = "";
                try {
                    errorMessage  = JSON.parse(jqXHR.responseText).message;
                } catch (err){
                    errorMessage = jqXHR.responseText;
                }
                if (errorMessage.length>170) {
                    errorMessage = errorMessage.substr(0, 150) + "...";
                }
                AJS.log("The online database couldn't be setup up right now: " + jqXHR.responseText);
                setWait(false);
                setErrorMessage("");
                AJS.messages.error("#all-messages", {
                    title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.heroku.create.error", errorMessage),
                    //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                    closeable: true
                });
            });

            setWait(false);
            //callback && callback();
        }).fail(function(jqXHR, errorMessage, errorObject){
            var errorMessage = "";
            try {
                errorMessage  = JSON.parse(jqXHR.responseText).message;
            } catch (err){
                errorMessage = jqXHR.responseText;
            }
            if (errorMessage.length>170) {
                errorMessage = errorMessage.substr(0, 150) + "...";
            }
            AJS.log("The online database couldn't be setup up right now: " + jqXHR.responseText);
            setWait(false);
            setErrorMessage("");
            AJS.messages.error("#all-messages", {
                title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.heroku.create.error", errorMessage),
                //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                closeable: true
            });
        });
    }
    function checkHerokuStatus(email){
        var url = AJS.contextPath() + '/rest/playsql/1.0/provisioning';
        $.ajax({
            url: url + "/syncdb",
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: 'json',
            data: JSON.stringify({
                email: email
            })
        }).done(function(data) {
            if (!data || !data.status) {
                $("#all-messages").empty();
                var text = typeof data == "string" ? data : JSON.stringify(data);
                AJS.messages.success("#all-messages", {
                    title: "An error occured",
                    body: AJS.escapeHtml(text),
                    closeable: true
                });
            } else {
                $("#all-messages").empty();
                AJS.messages.success("#all-messages", {
                    title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.heroku.synchronize.success"),
                    body: AJS.escapeHtml(data.message),
                    closeable: true
                });
                if (data.status == "PROVISIONED") {
                    $(".db-status").text("Online database provisioned").removeClass("aui-lozenge-current").addClass("aui-lozenge-success");
                    if ($("#setup-heroku #button-next").length > 0) {
                        $("#button-sync").removeClass("aui-button-primary");
                        $("#button-next").removeClass("hidden");
                    }
                } else if (data.status == "NOT_YET") {
                    $(".db-status").text("Not yet").removeClass("aui-lozenge-success").addClass("aui-lozenge-current");
                } else if (data.status == "UNINSTALLED") {
                    $(".db-status").text("Uninstalled").removeClass("aui-lozenge-success").addClass("aui-lozenge-current");
                } else if (data.status == "TRANSFERRED") {
                    $(".db-status").text("Transferred").removeClass("aui-lozenge-success").addClass("aui-lozenge-current");
                }
            }
        }).fail(function(jqXHR, errorMessage, errorObject){
            setWait(false);
            setErrorMessage("");
            $(".heroku-details").first().text("");
            AJS.messages.error("#all-messages", {
                title: AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.heroku.synchronize.error"),
                //body: "<p>" + AJS.I18n.getText("updates.retrieve.failed.description") + "</p>",
                closeable: true
            });
        });
    }
    function transferHerokuAccount(email){
        var url = AJS.contextPath() + '/rest/playsql/1.0/provisioning';
        $(".heroku-transfer-form").text("Contacting...");
        setWait(true);
        $.ajax({
            url: url + "/request-ownership",
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: 'text',
            data: JSON.stringify({
                email: email
            })
        }).done(function(data) {
            $(".heroku-transfer-form").text("Ownership request successful. The support will be in contact with you shortly.");
            setWait(false);
        }).fail(function(jqXHR, errorMessage, errorObject){
            var message = "An error occurred while contacting the server. Try again later, or contact support for help.";
            setWait(false);
            $(".heroku-transfer-form").text(message);
        });
    }
    function disconnectDb(){
        var url = AJS.contextPath() + '/rest/playsql/1.0/provisioning';
        $(".heroku-disconnect-form").text("Contacting...");
        $.ajax({
            url: url + "/disconnect-db",
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: 'text',
            data: JSON.stringify({
                email: 1
            })
        }).done(function(data) {
            $(".heroku-disconnect-form").text("Success. Redirecting...");
            window.location.href = AJS.contextPath() + "/admin/plugins/com.playsql.playsql-base-plugin/setup.action?activeTab=setup-db";
        }).fail(function(jqXHR, errorMessage, errorObject){
            var message = "An error occured while contacting the server. Try again later, or contact support for help.";
            $(".heroku-disconnect-form").text(message);
        });
    }
    function resetProvisioningApiToken(){
        /** This function is not wired to the user interface, but may be useful in some
         * very rare specific cases. Please only use it on recommendation of the Play SQL Support.
         */
        var url = AJS.contextPath() + '/rest/playsql/1.0/provisioning';
        $.ajax({
            url: url + "/reset",
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false
        }).done(function(data) {
            console.log("Success. Please refresh the page.");
            console.log(data);
        }).fail(function(jqXHR, errorMessage, errorObject){
            console.log("Error");
            console.log(jqXHR.responseText);
        });
    }
    window.PlaySQL_resetApiToken = resetProvisioningApiToken;
    function setupPlaySQLProd(dialect, jndiName, callback) {
        setWait(true);
        var url = AJS.contextPath() + '/rest/playsql/1.0/datasources',
            cnx = {
                context: {},
                type: "JNDI",
                dialect: "com.playsql.jdbc.dialect.PostgreSQLDDLDialect",
                jndiName: jndiName,
                initSQL: "",
                schema: "SPACE_[PERSONAL_]$spaceKey",
                testSQL: "",
                closeSQL: "",
                mode: "READ_WRITE"
            };
        $.ajax({
            url: url,
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            cache: false,
            dataType: "json",
            data: JSON.stringify(cnx)
        }).done(function(data) {
            callback();
        }).fail(function(jqXHR, errorMessage, errorObject){
            setWait(false);
            setErrorMessage(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.error.remove-connection"));
            AJS.logError("The settings couldn't be saved - " + jqXHR + " - " + errorMessage + " - " + errorObject);
        });
    }

    function setWait(waiting) {
        if (waiting == true || waiting == undefined) {
            setErrorMessage("");
            $("#db-setup-btn").html("<span id='savebar-throbber' class='aui-icon aui-icon-wait'>" + AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.setup-wait") + "</span>&nbsp;" + AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.setup-next"));
        } else {
            $("#db-setup-btn").empty().text(AJS.I18n.getText("com.playsql.base.web.admin.SetupAction.setup-next"));
        }
    }
    function setErrorMessage(message) {
        $("#form-error-messages .error").text(message);
    }
});