AJS.bind("init.rte", function() {
    var dialog;
    var editor = {
        html : function(){
            var src = AJS.contextPath() + '/plugins/servlet/I2SS/browser?' + $.param({
                    spaceKey: AJS.Meta.get('space-key'),
                    ceoId: AJS.Meta.get('content-id') || AJS.Meta.get('page-id')
                });
            var $iframe = $("<iframe></iframe>")
                .attr('id', 'playsql-editor-preview')
                .attr('src', src)
                .css('border', 'none');
            editor.iframe = $iframe[0];
            return $iframe;
        },
        init : function(body, params){
            this.body = body;
            if (typeof params == "string") {
                params = AJS.$.parseJSON(params);
            };
            this.params = params;
            var repeatHandler = window.setInterval(function(){
                var subWindow = editor.iframe.contentWindow;
                if (subWindow && subWindow.PlaySQLBrowser && subWindow.PlaySQLBrowser.initialized) {
                    window.clearInterval(repeatHandler);
                    subWindow.PlaySQLBrowser.synchronizeValues($.extend({sql:body}, params));
                    subWindow.PlaySQLBrowser.query();
                }
            }, 100);
        },
        /** Gather the configuration and the body, for example before a save */
        getMacroParams : function(){
            var subWindow = editor.iframe.contentWindow;
            if (!subWindow.PlaySQLBrowser || !subWindow.PlaySQLBrowser.initialized) {
                return;
            }

            var data = subWindow.PlaySQLBrowser.synchronizeValues();
            // Note that we should never save 'open-browser', because that would make the browser to open by default.
            var propertiesToSave = [/*'readonly'*/, 'space-key', 'context', 'timeout', 'user-parameters',
                'built-in-parameters', 'orderby', 'groupby'];
            this.params = {};
            for (var i = 0; i < propertiesToSave.length; i++) {
                var parameter = propertiesToSave[i];
                if (data[parameter]) {
                    this.params[parameter] = data[parameter];
                    // If using the current space, don't save it
                    if (parameter == 'context' && ('space:' + AJS.Meta.get('space-key')) == data[parameter]) {
                        delete this.params[parameter];
                    }
                }
            }
            if (data.sql) {
                this.body = data.sql;
            }
            return {
                body : this.body,
                params : this.params
            };
        }
    };

    AJS.MacroBrowser.setMacroJsOverride('playsql', {
        opener : function(macro) {
            var macroNode = $(tinymce.confluence.macrobrowser.getCurrentNode());

            if (typeof dialog == "undefined") {
                dialog = new AJS.Dialog({
                    id : 'playsql-macro-settings-dialog',
                    width : $(window).width() - 50,
                    height : $(window).height() - 50
                });
                dialog.addPanel("Play SQL Macro Settings", editor.html(), "playsql-editor-popup", 1);

                dialog.addSubmit("Save", function() {
                    var macro = editor.getMacroParams();
                    if (!macro) {
                        // Add message
                        AJS.logError("The Play SQL browser isn't ready to save");
                        return;
                    }
                    tinymce.confluence.macrobrowser.macroBrowserComplete({name:"playsql", "bodyHtml": macro.body, "params" : macro.params});
                    dialog.hide();
                });
                dialog.addCancel("Cancel", function () {
                    tinymce.confluence.macrobrowser.macroBrowserCancel();
                    dialog.hide();
                });
                $(window).resize($.debounce(function(){
                    if (dialog.isVisible()) {
                        dialog.popup.changeSize($(window).width() - 50, $(window).height() - 50);
                        dialog.getPanel(0).body.css('height', $(window).height() - 90);
                    }
                }, 50));
            }
            dialog.show();

            editor.init(macro.body, macro.params || {});
        }
    });
});