var PlaySQLMacro = (function() {
    var $ = AJS.$;

    function initialize($playsql) {
        if ($playsql.data("initialized")) {
            AJS.log("PlaySQL is already initialized.");
            return;
        }
        $playsql.data("initialized", true);

        var $placeholder = $playsql.closest('.playsql-placeholder');
        $placeholder.find('.playsql-user-parameters .submit-user-parameters').click(function(){
            PlaySQLMacro.load($placeholder);
        });
        $placeholder.find('.playsql-user-parameters input').keypress(function(e){
            if (e.keyCode == 13) {
                PlaySQLMacro.load($placeholder);
            }
        });
    }


    return {
        Renderer : {
            key : "abstract-renderer"
        },
        /** $playsql must be a "table.playsql" element. */
        initialize : initialize,
        /** $placeholder must be a jQuery object of <div class="playsql-placeholder" data-sql="SELECT * FROM PERSON"> */
        load : function ($placeholder) {
            var htmlRest = AJS.contextPath() + "/rest/playsql/1.0/playsql/html",
                data = $placeholder.data(),
                macroParameters = {},
                jsonParameters = [],//['user-parameters', 'groupby', 'orderby'], jquery already applies isJSON.
                $userParameters = $('.playsql-user-parameters input', $placeholder),
                ceoId = AJS.Meta.get("content-id") || AJS.Meta.get("page-id");
            for (var key in data) {
                var key2 = key.replace(/([a-z\d])([A-Z])/g, '$1-$2').toLowerCase();
                if (key2.indexOf('macro-') == 0) {
                    var name = key2.substring(6);
                    if ($.inArray(name, jsonParameters)) {
                        macroParameters[name] = data[key];
                    } else {
                        macroParameters[name] = $.parseJSON(data[key]);
                    }
                }
            }
            if ($userParameters.size() > 0 && macroParameters['user-parameters']) {
                var parameters = macroParameters['user-parameters'];
                $userParameters.each(function(i){
                    var $this = $(this),
                        name = $this.attr('name'),
                        val = $this.val(),
                        parameter = parameters[i];
                    if (parameter && name == parameter.name) {
                        parameter.value = val;
                    }
                });
            }
            if (!macroParameters.context || macroParameters.context == 'space:' || macroParameters.context == 'name:') {
                var spaceKey = AJS.Meta.get('space-key');
                if (spaceKey)
                    macroParameters.context = 'space:' + spaceKey;
            }
            for (var key in macroParameters) {
                var value = macroParameters[key];
                if (value == undefined || value === "" || (key != "sql" && typeof value == "string" && value.indexOf("$") == 0))
                    delete macroParameters[key];
            }
            if (ceoId) macroParameters["ceoId"] = ceoId;
            $.ajax({
                url:htmlRest,
                type: 'POST',
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(macroParameters),
                timeout: 180000
            }).done(function(data) {
                $placeholder.html(data.html);
                if (!macroParameters.readonly) {
                    $placeholder.find("table.playsql").each(function() {
                        initialize($(this));
                    });
                }
            }).fail(function(jqXHR, errorMessage, errorObject){
                AJS.logError("PlaySQL: Error while retrieving data.", jqXHR, errorMessage, errorObject);
                $placeholder.html("Could not display PlaySQL: " + errorMessage);
            });
            $placeholder.find('table:first').addClass('loading');
        }
    };
})();

AJS.$(document).ready(function($) {
    // Initialise the playsql
    $("div.playsql-placeholder").each(function() {
        var $placeholder = $(this);
        PlaySQLMacro.load($placeholder);
    });
});

