(function($){
    Confluence = Confluence || {};
    Confluence.PlaySQL = Confluence.PlaySQL || {};
    Confluence.PlaySQL.Messages = Confluence.PlaySQL.Messages || {};
    var idLastMessage = 1000;

    /**
     * Displays a message in the side bar
     * @param type error, warn, info
     * @param message the message
     * @param id (optional) an id
     * @returns the id
     */
    Confluence.PlaySQL.Messages.addMessage = function(type, message, id, jqXHRResponseText){
        if (!Confluence.PlaySQL.Messages.debugMode) {
            AJS.log("Play SQL: " + type + " - " + message + " class:" + id + " - ResponseText:" + jqXHRResponseText);
            var firstLine = jqXHRResponseText != undefined && ("\n" + jqXHRResponseText.split(/[\n\r]/)[0]) || "";
            if (firstLine.length > 100) firstLine = "";
            alert(type.charAt(0).toUpperCase() + type.substr(1) + ": " + message + firstLine);
            return id || idLastMessage++;
        }

        // Clean up
        $("p.tip:not(.playsql-message-inner)").remove();

        // Set the id
        if (id == undefined) {
            id = idLastMessage++;
        } else {
            Confluence.PlaySQL.Messages.removeMessage(id);
        }
        var $body = $("<p></p>", {
            "class": "tip playsql-message-inner",
            id: "playsql-message-" + id,
            text: " : " + message
        }).prepend($("<b></b>").text(type.toUpperCase()));

        // Insert
        var $location = $("hr.playsql-messages");
        if ($location.size() == 0) {
            $location = $(".acs-nav .advanced-links-section").first();
            if ($location.size() == 0)
            {
                $location = $(".acs-nav hr").first();
                if ($location.size() == 0) {
                    throw "Couldn't display error because there si no sidebar - " + type + message + id;
                }
            }
            $location.after($("<hr/>", {
                "class": "playsql-messages"
            }));
            $location = $("hr.playsql-messages");
        }
        $location.after($body);
        return id;
    };
    Confluence.PlaySQL.Messages.removeMessage = function(id){
        var $p = $("#playsql-message-" + id);
        $p.remove();

    };

    /*
     * Converts an element into a spinner.
     */
    Confluence.PlaySQL.Messages.spin = function ($element) {
        var response = {
            on: function(delay, title){
                // This data attribute also tells whether off() was already called.
                $element.attr("data-html-replacement", $element.html());
                function establish() {
                    if (typeof $element.attr("data-html-replacement") != "undefined") {
                        $("<span></span>", {
                            "class": "aui-icon aui-icon-wait",
                            "title": title,
                            text: "Wait"
                        }).appendTo($element.empty());
                    }
                }
                if (delay == undefined)
                    establish();
                else
                    window.setTimeout(establish, delay);
                return response;
            },
            off: function() {
                var html = $element.attr("data-html-replacement");
                $element.removeAttr("data-html-replacement");
                if (html) {
                    $element.empty().html(html);
                    $element.removeAttr("data-html-replacement");
                    // This doesn't rebind the handlers
                }
            }
        };
        return response;
    }



})(AJS.$);