AJS.$(function($) {
    function addDatasource(dataSource) {
        if (false && !dataSource["context"].spaceKey && !dataSource["context"].name) {
            // That's the DEFAULT_CONTEXT. Let's fill the form instead of filling a row.

        } else {
            var $newRow = $($("#datasource-tr").text());

            $newRow.find(".cell-context").data("context", dataSource["context"]);

            if (dataSource["context"].spaceKey) {
                var $link = $("<a/>").attr("href", AJS.contextPath() + "/playsql-base-plugin/space-admin.action?key=" + dataSource["context"].spaceKey)
                    .text("Space: " + dataSource["context"].spaceKey);
                $newRow.find(".cell-context").html($link);
            } else if (dataSource["context"].name) {
                $newRow.find(".cell-context").text(dataSource["context"].name);
            } else {
                $newRow.find(".cell-context").text("Instance");
            }

            $newRow.find(".cell-type").text(dataSource["type"]);
            if (dataSource["type"] == "DIRECT") {
                $newRow.find(".cell-jndi").remove();
                $newRow.find(".cell-driver").text(dataSource["driver"]);
                $newRow.find(".cell-url").text(dataSource["url"]);
                $newRow.find(".cell-username").text(dataSource["username"]);
                $newRow.find(".cell-dialect").text(dataSource["dialect"].substring(dataSource["dialect"].lastIndexOf('.')+1));
                $newRow.find(".cell-initSQL").text(dataSource["initSQL"]);
                $newRow.find(".cell-testSQL").text(dataSource["testSQL"]);
            } else if (dataSource["type"] == "JNDI") {
                $newRow.find(".cell-direct").remove();
                $newRow.find(".cell-jndi-details").text(dataSource["jndiName"]);
                $newRow.find(".cell-dialect").text(dataSource["dialect"].substring(dataSource["dialect"].lastIndexOf('.')+1));
                $newRow.find(".cell-initSQL").text(dataSource["initSQL"]);
                $newRow.find(".cell-testSQL").text(dataSource["testSQL"]);
            } else {
                $newRow.find(".cell-direct").remove();
                $newRow.find(".cell-jndi").remove();
                $newRow.find(".cell-sql").remove();
            }

            // Update the edit button
            if (dataSource["context"].name == "Factory Settings") {
                $newRow.find(".cell-edit-action").remove();
            } else {
                if (dataSource["context"].spaceKey) {
                    $newRow.find(".cell-edit-action")
                        .attr("href", "global-admin.action?contextSpaceKey=" + (dataSource["context"].spaceKey || ""))
                        .attr("data-context-space-key", (dataSource["context"].spaceKey || ""));
                } else {
                    $newRow.find(".cell-edit-action")
                        .attr("href", "global-admin.action?contextName=" + (dataSource["context"].name || ""))
                        .attr("data-context-name", (dataSource["context"].name || ""));
                }
            }
        }

        $("#datasource-list").append($newRow);
    }

    $("#dataSourceDialect").change(function(){
        var dialect = $(this).val(),
            $option = $(this).find("option[value='" + dialect + "']"),
            driver = $option.attr("data-driver"),
            driverMinimum = $option.attr("data-driver-minimum"),
            urlExample = $option.attr("data-url-example"),
            urlMinimum = $option.attr("data-url-minimum"),
            titleText = $option.attr("data-title-text"),
            titleLink = $option.attr("data-title-link"),
            $hint = $('#dataSourceDialect').parent().find(".description").empty();

        if (!$('#dataSourceDriver').val().indexOf(driverMinimum) != -1){
            $('#dataSourceDriver').val(driver);
        }
        if (!$('#dataSourceUrl').val().indexOf(urlMinimum) != -1){
            $('#dataSourceUrl').val(urlExample);
        }
        $hint.text(titleText);
        titleLink && $hint
            .append(" ")
            .append($("<a>", {
                text: "(Link)",
                href: titleLink,
                target: "_blank"
            }));

    });
    /*
     var htmlRest = AJS.contextPath() + "/rest/playsql/1.0/admin/listDatasources";

     $.getJSON(htmlRest, {}, function(data) {
     for ( var i in data) {
     addDatasource(data[i]);
     }
     });*/

    // Space Admin
    function updateCollapsibleFields() {
        var status = $("input[name='dataSourceType']:checked").val();
        if (status == 'inherit') {
            $(".dbcp-details").hide();
            $(".jndi-details").hide();
            $(".check-sql").hide();
        } else if (status == 'jndi') {
            $(".dbcp-details").hide();
            $(".jndi-details").show();
            $(".check-sql").show();
        } else if (status == 'disabled') {
            $(".dbcp-details").hide();
            $(".jndi-details").hide();
            $(".check-sql").hide();
        } else if (status == 'custom') {
            $(".dbcp-details").show();
            $(".jndi-details").hide();
            $(".check-sql").show();
        }
    }

    updateCollapsibleFields();
    $("input[name='dataSourceType']").click(updateCollapsibleFields);

    $("#driver-is-invalid").hide();
    $("#driver-is-valid").hide();

    $("#jdbc-test").click(function(e) {
        e.preventDefault();
        $("#jdbc-is-invalid").hide();
        $("#jdbc-is-valid").hide();
        $("#jdbc-message").text("");
        if ($("#dataSourceJndi").is(":visible")) {
            data = {
                jndi : $("#dataSourceJndi").val(),
                initSQL : $("#dataSourceInitSQL").val(),
                testSQL : $("#dataSourceTestSQL").val(),
                spaceKey : $("#dataSourceContextSpace").val()
            };
        } else {
            data = {
                className : $("#dataSourceDriver").val(),
                dialect : $("#dataSourceDialect").val(),
                url : $("#dataSourceUrl").val(),
                username : $("#dataSourceUsername").val(),
                password : $("#dataSourcePassword").val(),
                initSQL : $("#dataSourceInitSQL").val(),
                testSQL : $("#dataSourceTestSQL").val(),
                spaceKey : $("#dataSourceContextSpace").val()
            };
        }
        $.ajax({
            url : AJS.contextPath() + "/rest/playsql/1.0/admin/testJdbc",
            data : data,
            success : function(data) {
                if (data.status == "ok") {
                    $("#jdbc-is-valid").show();
                    $("#jdbc-message").text(data.testSQL);
                } else {
                    $("#jdbc-is-invalid").show();
                    $("#jdbc-message").text(data.exception);
                }
            }
        });
    });
    $("#jdbc-is-invalid").hide();
    $("#jdbc-is-valid").hide();

    var $autocompleteJndi = $("#datasourcelist"), hoveringJndiAutocomplete = false;

    $autocompleteJndi.hover(function() {
        hoveringJndiAutocomplete = true;
    }, function() {
        hoveringJndiAutocomplete = false;
    });

    $autocompleteJndi.hide();
    $autocompleteJndi.children().remove();
    $("#dataSourceJndi").focus(function() {
        $autocompleteJndi.show();
    });
    $("#dataSourceJndi").click(function() {
        $autocompleteJndi.show();
    });
    $("#dataSourceJndi").blur(function() {
        if (hoveringJndiAutocomplete) {
            $autocompleteJndi.mouseleave(function() {
                $autocompleteJndi.hide();
            });
        } else {
            $autocompleteJndi.hide();
        }
    });

    $.ajax({
        url : AJS.contextPath() + "/rest/playsql/1.0/admin/listJndiJdbc?spaceKey=" + $("#dataSourceContextSpace").val(),
        /*data : {
         className : $("#dataSourceDriver").val(),
         url : $("#dataSourceUrl").val(),
         username : $("#dataSourceUsername").val(),
         password : $("#dataSourcePassword").val(),
         initSQL : $("#dataSourceInitSQL").val(),
         testSQL : $("#dataSourceTestSQL").val()
         },*/
        success : function(data) {
            for ( var classLoaderIndex in data) {
                for ( var name in data[classLoaderIndex]) {
                    if (name.indexOf("java:comp") == 0) {
                        var $suggestion = $("<li/>"), $link = $('<a href="#"/>');

                        $link.addClass("item-link");
                        $link.text(name + " (" + data[classLoaderIndex][name] + ")");
                        $link.data("jndi", name);

                        $link.click(function(e) {
                            $("#dataSourceJndi").val($(this).data("jndi"));
                            $autocompleteJndi.hide();
                            e.preventDefault();
                        });

                        $suggestion.append($link);
                        $suggestion.addClass("dropdown-item");

                        $autocompleteJndi.append($suggestion);
                    }
                }
            }
        }
    });

    /* === Audit Trail === */
    function updateVisibleFields() {
        var enabled = $("#audittrail-enabled").is(":checked"),
            policy = $("input[name='duration']:checked").attr("data-policy"),
            duration = $("#duration").val();

        if (!enabled) {
            $(".field-policy-title, .field-policy, .field-duration").addClass("hidden");
        } else if (policy == 'KEEP_ALL') {
            $(".field-policy-title, .field-policy").removeClass("hidden");
            $(".field-duration").addClass("hidden");
        } else if (policy == 'TIME_BASED' || policy == 'COUNT_BASED') {
            $(".field-policy-title, .field-policy, .field-duration").removeClass("hidden");
            if (duration == "" || duration == "14" || duration == "1000") {
                duration = policy == 'TIME_BASED' ? '14' : '1000';
                $("#duration").val(duration);
            }
            if (policy == 'TIME_BASED') {
                $(".duration-days").removeClass("hidden");
                $(".duration-qty").addClass("hidden");
            } else {
                $(".duration-days").addClass("hidden");
                $(".duration-qty").removeClass("hidden");
            }
        } else {
            policy = 'KEEP_ALL';
            $("#duration-forever").attr("checked", "checked");
            $(".field-policy-title, .field-policy").removeClass("hidden");
            $(".field-duration").addClass("hidden");
        }
    }
    $("input[name='audittrail'], input[name='duration'], input#qty-COUNT_BASED, input#qty-TIME_BASED").change(function() {
        updateVisibleFields();
    });

    function saveAuditTrail() {
        updateVisibleFields();
        var enabled = $("#audittrail-enabled").is(":checked"),
            policy = $("input[name='duration']:checked").attr("data-policy"),
            duration = $("#duration").val();

        var spaceKey = AJS.Meta.get("space-key"),
            url = AJS.contextPath() + "/rest/playsql-spreadsheets/1.0/space:" + spaceKey + "/audittrail";

        $.ajax({
            url: url,
            type: 'PUT',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            data: JSON.stringify({
                enabled: enabled,
                policy: policy,
                duration: duration
            })
        }).done(function(data) {
            AJS.messages.success(".aui-messages", {
                body: "Saved."
            });
        }).fail(function(jqXHR, errorMessage, errorObject){
            var message = jqXHR.responseText;
            if (message.length > 200) message = message.substr(message, 200) + "...";
            AJS.messages.warning(".aui-messages", {
                body: "An error was encountered while saving the settings: " + AJS.escapeHtml(message)
            });
        });
    }
    $("#submit-audittrail").click(function(e){
        e.preventDefault();
        saveAuditTrail();
        return false;
    });
    if ($("#space-admin-body").hasClass("audit-trail")) {
        updateVisibleFields();
    }

});


