AJS.$(function($){
    Confluence.PlaySQL = Confluence.PlaySQL || {};
    Confluence.PlaySQL.SpacePicker = Confluence.PlaySQL.SpacePicker || {};
    Confluence.PlaySQL.SpacePicker.createDialog = function(headerText, text, callback) {
        var dialog;
        if (Confluence.PlaySQL.SpacePicker.dialog) {
            dialog = Confluence.PlaySQL.SpacePicker.dialog;
            delete Confluence.PlaySQL.SpacePicker.dialog;
            try {
                dialog.remove();
            } catch (err) {}
        }

        var $template = $(Confluence.Templates.PlaySQL.spacePickerForm({
                text: text
            })),
            submitCallback = function () {
                callback("ds", "Demonstration Space");
                delete Confluence.PlaySQL.SpacePicker.dialog;
                dialog.remove();
                return false;
            },

            cancelCallback = function () {
                dialog.remove();
                delete Confluence.PlaySQL.SpacePicker.dialog;
            },

            dialog = new AJS.ConfluenceDialog({
                width: 500,
                height: 350,
                // height: 550, No default height.
                id: 'space-picker-dialog',
                closeOnOutsideClick: true,
                onCancel: cancelCallback,
                onSubmit: submitCallback
            });

        dialog.addHeader(headerText);
        dialog.addPanel("Panel 1", $template);

        dialog.addSubmit("Save", submitCallback);
        dialog.addCancel("Cancel", cancelCallback);

        $submitButton = dialog.popup.element.find('.button-panel-submit-button');

        dialog.gotoPage(0);
        dialog.gotoPanel(0);

        Confluence.PlaySQL.SpacePicker.dialog = dialog;
        return {
            show: function() {
                Confluence.PlaySQL.SpacePicker.dialog.show();
                Confluence.PlaySQL.SpacePicker.addAutocomplete($("#space-picker-input"), $("#space-picker-autocomplete"), function(spaceKey, spaceName){
                    var dialog = Confluence.PlaySQL.SpacePicker.dialog;
                    delete Confluence.PlaySQL.SpacePicker.dialog;
                    try {
                        dialog.hide().remove();
                    } catch (err) {}

                    callback(spaceKey, spaceName);
                });
            },
            remove: function() {
                var dialog = Confluence.PlaySQL.SpacePicker.dialog;
                delete Confluence.PlaySQL.SpacePicker.dialog;
                try {
                    dialog.hide().remove();
                } catch (err) {}
            }
        };
    }

    Confluence.PlaySQL.SpacePicker.addAutocomplete = function($element, $hiddenDiv, addSpaceCallback, ignoreSpace) {
        var $spaceAutocompleteUl = $("<ul></ul>")
            .appendTo($hiddenDiv
                .addClass("aui-dropdown2 aui-style-default")
                .attr("id", "space-picker-autocomplete")
                .css("z-index", "4000")
                .empty());

        $.ajax({
            url : AJS.contextPath() + "/rest/create-dialog/1.0/spaces?promotedSpacesLimit=5&otherSpacesLimit=1000",
            success : function(data) {
                var countPromoted = 0;
                for (var i = 0; i < data.promotedSpaces.spaces.length; i++) {
                    countPromoted++;
                    addElement(data.promotedSpaces.spaces[i].id, data.promotedSpaces.spaces[i].text, "promoted");
                }
                for (var i = 0; i < data.otherSpaces.spaces.length; i++) {
                    addElement(data.otherSpaces.spaces[i].id, data.otherSpaces.spaces[i].text,
                        countPromoted++ < 5 ? "promoted" : undefined);
                }
                autocompleteSpaces();
            }
        });
        function addElement(key, name, className) {
            var $li = $("<li></li>", {
                    "class": "hidden" + (className ? " " + className : "")
                }).appendTo($spaceAutocompleteUl),
                $a = $("<a></a>", {
                    href: '#',
                    text: name + " (" + key + ")",
                    "data-space-key": key,
                    "data-space-name": name
                }).appendTo($li);
            $a.click(selectAutocompletedSpace);
        }
        function selectAutocompletedSpace() {
            var $selected = $(this),
                spaceKey = $selected.attr("data-space-key"),
                spaceName = $selected.attr("data-space-name");
            // Set the value and hide the popup
            $selected.remove();
            $element
                .val(spaceName)
                .trigger("aui-button-invoke");

            addSpaceCallback(spaceKey, spaceName);
            return false;
        }
        function autocompleteSpaces(startsWith) {
            if (!startsWith) {
                $spaceAutocompleteUl.children().addClass("hidden");
                $spaceAutocompleteUl.children(".promoted").removeClass("hidden disabled");
            } else {
                $spaceAutocompleteUl.children().each(function(){
                    var $this = $(this),
                        $a = $this.children().first(),
                        spaceKey = $a.attr("data-space-key") || "",
                        spaceName = $a.attr("data-space-name") || "",
                        beginning = startsWith.toLowerCase(),
                        alreadyAdded = ignoreSpace && ignoreSpace(spaceKey);
                    $a.removeClass("disabled");
                    if (!alreadyAdded && (spaceKey.toLowerCase().indexOf(beginning) != -1
                        || spaceName.toLowerCase().indexOf(beginning) != -1)) {
                        $this.removeClass("hidden disabled active");
                    } else {
                        $this.addClass("hidden");
                    }
                });
            }
        }
        $element.keyup(function(){
            var value = $(this).val();
            autocompleteSpaces(value);

            //if ($("#add-space-name:visible").size() == 0)
            //    $("#add-space-name").trigger("aui-button-invoke");
        }).keydown(function(e){
            var $input = $(this);
            if (e.which == 13) {
                addSpaceCallback($input.val(), $input.val());
                return false;
            }
        }).click(function(){
            $(this).select();
        }).attr('aria-owns', 'space-picker-autocomplete')
            .attr('aria-haspopup', 'true')
            .addClass('aui-dropdown2-trigger');

        $hiddenDiv.on({
            "aui-dropdown2-show": function() {
                $element.focus();
            }
        });
        // -- End of space list management

    }
});