(function($) {
    Confluence.PlaySQL = Confluence.PlaySQL || {};
    Confluence.PlaySQL.Query = Confluence.PlaySQL.Query || {};
    Confluence.PlaySQL.Query.piertotumLocomotor = function ($placeholder, options) {
        // Enable PlaySQL Selection on the query
        // With what-it-needs for the Totals
        Confluence.PlaySQL.Selection.forTable($placeholder).init($.extend({
            baseSelector: ".playsql-query-placeholder table",
            canSelectFooter: true,

            popupTrigger: ".totals-row .totals-calculation",
            popupContentFn: function($content, trigger, showPopup) {
                var fields = [],
                    exampleTemplates = ['SUM(%s)', 'ROUND(AVG(%s))', 'MAX(%s)'],
                    examples = [],
                    originalFieldName, fieldName, type, template;
                $placeholder.find("thead th:visible").each(function(){
                    var $this = $(this),
                        originalFieldName = $.trim($this.text()),
                        defaultCase = $placeholder.attr('data-ds-case') || 'LOWER',
                        fieldName = defaultCase == 'LOWER' ? originalFieldName.toLowerCase() : originalFieldName.toUpperCase();
                    if (originalFieldName != "") {
                        if (fieldName != originalFieldName) {
                            fieldName = '"' + originalFieldName + '"';
                        }
                        fields.push(fieldName);
                    }
                });

                $content.html(Confluence.Templates.PlaySQL.formulaHelp({fields:{'':fields}}));
                $content.children().first().on("click", ".examples a", function() {
                    $(trigger).val($(this).text()).focus();
                    Confluence.PlaySQL.Selection.inlineDialog && Confluence.PlaySQL.Selection.inlineDialog.hide();
                    return false;
                });
                showPopup();
            }
        }, options));
    }
})(AJS.$);