(function($){
    Confluence.PlaySQL = Confluence.PlaySQL || {};
    var ed = Confluence.PlaySQL.Spreadsheeteditor || {};
    Confluence.PlaySQL.SpreadsheetEditor = ed;

    /**
     * Initialize the form with the Spreadsheet object passed in argument
     */
    ed.initialize = function(context, id, spreadsheet) {
        $("#spreadsheet-table").text(spreadsheet.name);
        $("#spreadsheet-title").val(spreadsheet.label)
            .data("name", spreadsheet.name)
            .data("label", spreadsheet.label);
        //ed.preview();
        ed.baseUrl = function(endpoint, paths, queryParams) {
            var suffix = "";
            for (var i = 0 ; i < arguments.length ; i++) {
                var arg = arguments[i];
                if (i == arguments.length -1 && (typeof arg == "object")) {
                    suffix += "?" + $.param(arg);
                } else {
                    suffix += "/" + arg.replace(/^\/|\/$/g, "");
                }
            }

            return AJS.contextPath() + "/rest/playsql-spreadsheets/1.0/" + context + "/" + id + suffix;
        }
    };
    ed.getValues = function() {
        var $title = $("#spreadsheet-title"),
            title = $title.val(),
            name = $title.data("name"),
            tablename = $("#spreadsheet-table").val();
        return {
            name: name,
            label: title
        };
    }
    ed.save = function() {
        try {
            Confluence.PlaySQL.Editors.saveBarMessage("Saving...", true);
            var spreadsheet = ed.getValues(),
                name = spreadsheet.name,
                spaceKey = AJS.Meta.get("space-key"),
                url = ed.baseUrl("/label");
            $.ajax({
                url: url,
                type: 'PUT',
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: spreadsheet.label
            }).done(function(data){
                Confluence.PlaySQL.Editors.saveBarMessage("Saved!", false);
                $("#spreadsheet-title").data("label", data);
                if (window.opener &&
                    !window.opener.closed &&
                    window.opener.AJS &&
                    window.opener.AJS.MacroBrowser &&
                    window.opener.AJS.MacroBrowser.fields &&
                    window.opener.AJS.MacroBrowser.fields.spreadsheetId &&
                    window.opener.AJS.MacroBrowser.fields.spreadsheetId.updateSpreadsheet)
                {
                    window.opener.AJS.MacroBrowser.fields.spreadsheetId.loadedSpreadsheetId = "please refresh anyway";
                    window.opener.AJS.MacroBrowser.fields.spreadsheetId.updateSpreadsheet();
                }
            }).fail(function(data){
                Confluence.PlaySQL.Editors.saveBarMessage("Error while saving. Try again?", false);
            });
        }
        catch (err) {
            AJS.logError(err);
        }
        return false;
    }

    ed.preview = function() {
        Confluence.PlaySQL.Spreadsheet.initializeAll();
        return false;
    }
})(AJS.$);

AJS.$(function($){
    var ed = Confluence.PlaySQL.SpreadsheetEditor,
        $placeholder = $("#spreadsheet-form .playsql-spreadsheet-placeholder");
    if ($placeholder.size() == 0) {
        return;
    }

    $("#dropdown-add-options").on("click", "a", function(e){
        var $this = $(this);
        // Implement, whenever we have extra fields...
        return false;
    });
    $("#spreadsheet-editor-bottom").on("click", ".remove", function(){
        var $this = $(this);
        // Implement, whenever we have extra fields
    });
    $("#spreadsheet-title").blur(function() {
        var $title = $("#spreadsheet-title");
        if ($title.data("label") != $title.val()) {
            ed.save();
        }
        //ed.preview();
        return false;
    });
    $(".btn-preview").click(function(e){
        // Prevent from submitting the form
        e.preventDefault();
    });
    $("#spreadsheet-form").submit(function(e){
        // Prevent from submitting the form
        e.preventDefault();
    });

    // Initialize
    var initialData = $("#spreadsheet-form").data("initial-data"),
        context = $placeholder.attr("data-macro-context"),
        id = $placeholder.attr("data-macro-spreadsheet-id");
    ed.initialize(context, id, initialData);
});
